/*Author: Eric Dluzen
  Date: 2021-02-28
*/

#include <MFRC522.h>

#include <DFRobotDFPlayerMini.h>
#include <SoftwareSerial.h>
#include <SPI.h>
#include <MFRC522.h>
#include <Adafruit_NeoPixel.h>

#define PIN 8
#define N_LEDS 54
Adafruit_NeoPixel strip = Adafruit_NeoPixel(N_LEDS, PIN);

static const uint8_t PIN_MP3_TX = 2; // Connects to module's RX
static const uint8_t PIN_MP3_RX = 3; // Connects to module's TX
SoftwareSerial softwareSerial(PIN_MP3_RX, PIN_MP3_TX);
DFRobotDFPlayerMini player;

#define SS_PIN 10
#define RST_PIN 9
#define ACCESS_DELAY 2000
#define DENIED_DELAY 1000
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.

//sound 
 int MagicBandSound = 2; //labled 1
 int RocknRoll = 3; //labled 2
 int Pirates = 4; //labled 3
 int JungleCruise = 5; //labled 4
 int SpaceMountain = 1; //labled 5


void setup() 
{
  strip.begin(); //Needs to be before SPI.begin
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();          // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  softwareSerial.begin(9600); //need this to keep speaker working
  
  player.begin(softwareSerial);
  
  Serial.println("Put your card to the reader...");
  Serial.println();
  
  
}

void loop() 
{
  Serial.println("Made it back to top");
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    Serial.println("in the new card loop");
    return;
  }
   //Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    Serial.println("in the read card loop");
    return;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
    String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  if (content.substring(1) == "0E 48 8D B9") //change here the UID of the card/cards that you want to give access
  {
    Serial.println(" Pirates");
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(Pirates); //play file in 1st spot
    player.play(Pirates);
    //brightFade(75);
    brightFadeFast(1);
    brightFadeFast(1);
    brightFadeFast(1);
    brightFadeFast(1);
    colorWipe(strip.Color(0, 0, 0), 10); //RGB
  }
  
 else if (content.substring(1) == "1E 43 8C B9")
 {
    Serial.println(" Rock n Roll");
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(RocknRoll); //play file in 1st spot
    player.play(RocknRoll);
    colorWipe(strip.Color(100, 100, 0), 750); //RGB
    colorWipe(strip.Color(0, 0, 0), 750); //RGB
    colorWipe(strip.Color(100, 100, 0), 750); //RGB
    colorWipe(strip.Color(0, 0, 0), 500); //Blank
    colorWipe(strip.Color(0, 100, 0), 2000); //RGB
    colorWipe(strip.Color(0, 0, 0), 10); //RGB
  }

  else if (content.substring(1) == "2E 47 8C B9") // Band
 {
    Serial.println("Authorized Access");
    Serial.println();
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(MagicBandSound); //play file in 1st spot
    player.play(MagicBandSound);
    colorWipe(strip.Color(75, 0, 130), 2500); //RGB
    colorWipe(strip.Color(0, 0, 0), 10); //Blank
  }

else if (content.substring(1) == "1E 41 8C B9") //Space Mountain
 {
  Serial.println("Authorized Access");
    Serial.println();
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(SpaceMountain);
    player.play(SpaceMountain);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 100);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 80);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 30);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 30);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 30);
    brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 20);
        brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 20);
        brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 10);
        brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 10);
     brightFade(1);
    colorWipe(strip.Color(0, 0, 0), 10);
        brightFadePurple(1);
    colorWipe(strip.Color(0, 0, 0), 10);
 }
 

  else if (content.substring(1) == "3E 29 8C B9") //Jungle Cruise
 {
   Serial.println("Authorized Access");
    Serial.println();
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(JungleCruise);
    player.play(JungleCruise);
     colorWipe(strip.Color(0, 0, 0), 10);
    delay(2500);
    brightFadeSlow(55);
    colorWipe(strip.Color(0, 0, 0), 10);
 }
  
  
 else   {
    Serial.println("Authorized Access"); //0E 40 8C B9 is for Puck
    Serial.println();
    delay(500);
    SpiralupDown(strip.Color(100, 100, 100));
    player.volume(30); //volume 1 to 30
    player.play(MagicBandSound); //play file in 1st spot
    player.play(MagicBandSound);
    delay(20);
    colorWipe(strip.Color(0, 100, 0), 2500); //RGB
    colorWipe(strip.Color(0, 0, 0), 10); //Blank
  }
}


//Functions of Lighting
void SpiralupDown(uint32_t c) {
   for(int i=0; i<strip.numPixels()+3; i++) {
      strip.setPixelColor(i  , c); // Draw new pixel
      strip.setPixelColor(i-5, 0); // Erase Old LED Values
      strip.show();
      delay(20);}
  for(int i=N_LEDS; i>0; i--) {
       strip.setPixelColor(i, c);
       strip.setPixelColor(i+5, 0); // Erase Old LED Values
       strip.show();
       delay(20);}
}

void colorWipe(uint32_t c, int Delay)
   {
   for(int i=0; i<strip.numPixels(); i++) 
      {
      strip.setPixelColor(i, c); // Draw new pixel
      strip.show();
      }
      delay(Delay);
    }

void brightFade(int Delay)
  {
 for(int i=0; i<100; i +=30)
      { 
        for(int j=0; j<N_LEDS ; j++) //Loops through all lights
        {
          strip.setPixelColor(j, strip.Color(i, i, i));
          strip.show();
        }
        delay(Delay);
      }
  }

  void brightFadePurple(int Delay)
  {
 for(int i=0; i<100; i +=20)
      { 
        for(int j=0; j<N_LEDS ; j++) //Loops through all lights
        {
          strip.setPixelColor(j, strip.Color(i, 0, i));
          strip.show();
        }
        delay(Delay);
      }
  }

void brightFadeSlow(int Delay)
  {
 for(int i=0; i<100; i +=5)
      { 
        for(int j=0; j<N_LEDS ; j++) //Loops through all lights
        {
          strip.setPixelColor(j, strip.Color(0, 0, i));
          strip.show();
        }
        delay(Delay);
      }
  }
  
void brightFadeFast(int Delay)
{
   for(int i=0; i<100; i += 20)
      { 
        for(int j=0; j<N_LEDS ; j++) //Loops through all lights
        {
          strip.setPixelColor(j, strip.Color(0, i, i));
          strip.show();
        }
        delay(Delay);
      }
      for(int i=100; i>0; i -= 20)
      { 
        for(int j=0; j<N_LEDS ; j++)
        {
          strip.setPixelColor(j, strip.Color(0, i, i));
          strip.show();
        }
        delay(Delay);
      }
 }
